// @generated Do not edit this file, which is automatically generated by the generator.

package dbschema

import (
	"fmt"

	"time"

	"github.com/webx-top/com"
	"github.com/webx-top/db"
	"github.com/webx-top/db/lib/factory"
	"github.com/webx-top/db/lib/factory/pagination"
	"github.com/webx-top/echo"
	"github.com/webx-top/echo/param"
)

type Slice_NgingCodeInvitation []*NgingCodeInvitation

func (s Slice_NgingCodeInvitation) Range(fn func(m factory.Model) error) error {
	for _, v := range s {
		if err := fn(v); err != nil {
			return err
		}
	}
	return nil
}

func (s Slice_NgingCodeInvitation) RangeRaw(fn func(m *NgingCodeInvitation) error) error {
	for _, v := range s {
		if err := fn(v); err != nil {
			return err
		}
	}
	return nil
}

func (s Slice_NgingCodeInvitation) GroupBy(keyField string) map[string][]*NgingCodeInvitation {
	r := map[string][]*NgingCodeInvitation{}
	for _, row := range s {
		dmap := row.AsMap()
		vkey := fmt.Sprint(dmap[keyField])
		if _, y := r[vkey]; !y {
			r[vkey] = []*NgingCodeInvitation{}
		}
		r[vkey] = append(r[vkey], row)
	}
	return r
}

func (s Slice_NgingCodeInvitation) KeyBy(keyField string) map[string]*NgingCodeInvitation {
	r := map[string]*NgingCodeInvitation{}
	for _, row := range s {
		dmap := row.AsMap()
		vkey := fmt.Sprint(dmap[keyField])
		r[vkey] = row
	}
	return r
}

func (s Slice_NgingCodeInvitation) AsKV(keyField string, valueField string) param.Store {
	r := param.Store{}
	for _, row := range s {
		dmap := row.AsMap()
		vkey := fmt.Sprint(dmap[keyField])
		r[vkey] = dmap[valueField]
	}
	return r
}

func (s Slice_NgingCodeInvitation) Transform(transfers map[string]param.Transfer) []param.Store {
	r := make([]param.Store, len(s))
	for idx, row := range s {
		r[idx] = row.AsMap().Transform(transfers)
	}
	return r
}

func (s Slice_NgingCodeInvitation) FromList(data interface{}) Slice_NgingCodeInvitation {
	values, ok := data.([]*NgingCodeInvitation)
	if !ok {
		for _, value := range data.([]interface{}) {
			row := &NgingCodeInvitation{}
			row.FromRow(value.(map[string]interface{}))
			s = append(s, row)
		}
		return s
	}
	s = append(s, values...)

	return s
}

func NewNgingCodeInvitation(ctx echo.Context) *NgingCodeInvitation {
	m := &NgingCodeInvitation{}
	m.SetContext(ctx)
	return m
}

// NgingCodeInvitation 邀请码
type NgingCodeInvitation struct {
	base    factory.Base
	objects []*NgingCodeInvitation

	Id       uint   `db:"id,omitempty,pk" bson:"id,omitempty" comment:"ID" json:"id" xml:"id"`
	Uid      uint   `db:"uid" bson:"uid" comment:"创建者" json:"uid" xml:"uid"`
	RecvUid  uint   `db:"recv_uid" bson:"recv_uid" comment:"使用者" json:"recv_uid" xml:"recv_uid"`
	Code     string `db:"code" bson:"code" comment:"邀请码" json:"code" xml:"code"`
	Created  uint   `db:"created" bson:"created" comment:"创建时间" json:"created" xml:"created"`
	Used     uint   `db:"used" bson:"used" comment:"使用时间" json:"used" xml:"used"`
	Start    uint   `db:"start" bson:"start" comment:"有效时间" json:"start" xml:"start"`
	End      uint   `db:"end" bson:"end" comment:"失效时间" json:"end" xml:"end"`
	Disabled string `db:"disabled" bson:"disabled" comment:"是否禁用" json:"disabled" xml:"disabled"`
	RoleIds  string `db:"role_ids" bson:"role_ids" comment:"注册为角色(多个用“,”分隔开)" json:"role_ids" xml:"role_ids"`
}

// - base function

func (a *NgingCodeInvitation) Trans() *factory.Transaction {
	return a.base.Trans()
}

func (a *NgingCodeInvitation) Use(trans *factory.Transaction) factory.Model {
	a.base.Use(trans)
	return a
}

func (a *NgingCodeInvitation) SetContext(ctx echo.Context) factory.Model {
	a.base.SetContext(ctx)
	return a
}

func (a *NgingCodeInvitation) EventON(on ...bool) factory.Model {
	a.base.EventON(on...)
	return a
}

func (a *NgingCodeInvitation) EventOFF(off ...bool) factory.Model {
	a.base.EventOFF(off...)
	return a
}

func (a *NgingCodeInvitation) Context() echo.Context {
	return a.base.Context()
}

func (a *NgingCodeInvitation) SetConnID(connID int) factory.Model {
	a.base.SetConnID(connID)
	return a
}

func (a *NgingCodeInvitation) SetNamer(namer func(factory.Model) string) factory.Model {
	a.base.SetNamer(namer)
	return a
}

func (a *NgingCodeInvitation) Namer() func(factory.Model) string {
	return a.base.Namer()
}

func (a *NgingCodeInvitation) SetParam(param *factory.Param) factory.Model {
	a.base.SetParam(param)
	return a
}

func (a *NgingCodeInvitation) Param(mw func(db.Result) db.Result, args ...interface{}) *factory.Param {
	if a.base.Param() == nil {
		return a.NewParam().SetMiddleware(mw).SetArgs(args...)
	}
	return a.base.Param().SetMiddleware(mw).SetArgs(args...)
}

// - current function

func (a *NgingCodeInvitation) New(structName string, connID ...int) factory.Model {
	if len(connID) > 0 {
		return factory.NewModel(structName, connID[0]).Use(a.base.Trans())
	}
	return factory.NewModel(structName, a.base.ConnID()).Use(a.base.Trans())
}

func (a *NgingCodeInvitation) Objects() []*NgingCodeInvitation {
	if a.objects == nil {
		return nil
	}
	return a.objects[:]
}

func (a *NgingCodeInvitation) XObjects() Slice_NgingCodeInvitation {
	return Slice_NgingCodeInvitation(a.Objects())
}

func (a *NgingCodeInvitation) NewObjects() factory.Ranger {
	return &Slice_NgingCodeInvitation{}
}

func (a *NgingCodeInvitation) InitObjects() *[]*NgingCodeInvitation {
	a.objects = []*NgingCodeInvitation{}
	return &a.objects
}

func (a *NgingCodeInvitation) NewParam() *factory.Param {
	return factory.NewParam(factory.DefaultFactory).SetIndex(a.base.ConnID()).SetTrans(a.base.Trans()).SetCollection(a.Name_()).SetModel(a)
}

func (a *NgingCodeInvitation) Short_() string {
	return "nging_code_invitation"
}

func (a *NgingCodeInvitation) Struct_() string {
	return "NgingCodeInvitation"
}

func (a *NgingCodeInvitation) Name_() string {
	if a.base.Namer() != nil {
		return WithPrefix(a.base.Namer()(a))
	}
	return WithPrefix(factory.TableNamerGet(a.Short_())(a))
}

func (a *NgingCodeInvitation) CPAFrom(source factory.Model) factory.Model {
	a.SetContext(source.Context())
	a.Use(source.Trans())
	a.SetNamer(source.Namer())
	return a
}

func (a *NgingCodeInvitation) Get(mw func(db.Result) db.Result, args ...interface{}) (err error) {
	base := a.base
	if !a.base.Eventable() {
		err = a.Param(mw, args...).SetRecv(a).One()
		a.base = base
		return
	}
	queryParam := a.Param(mw, args...).SetRecv(a)
	if err = DBI.FireReading(a, queryParam); err != nil {
		return
	}
	err = queryParam.One()
	a.base = base
	if err == nil {
		err = DBI.FireReaded(a, queryParam)
	}
	return
}

func (a *NgingCodeInvitation) List(recv interface{}, mw func(db.Result) db.Result, page, size int, args ...interface{}) (func() int64, error) {
	if recv == nil {
		recv = a.InitObjects()
	}
	if !a.base.Eventable() {
		return a.Param(mw, args...).SetPage(page).SetSize(size).SetRecv(recv).List()
	}
	queryParam := a.Param(mw, args...).SetPage(page).SetSize(size).SetRecv(recv)
	if err := DBI.FireReading(a, queryParam); err != nil {
		return nil, err
	}
	cnt, err := queryParam.List()
	if err == nil {
		switch v := recv.(type) {
		case *[]*NgingCodeInvitation:
			err = DBI.FireReaded(a, queryParam, Slice_NgingCodeInvitation(*v))
		case []*NgingCodeInvitation:
			err = DBI.FireReaded(a, queryParam, Slice_NgingCodeInvitation(v))
		case factory.Ranger:
			err = DBI.FireReaded(a, queryParam, v)
		}
	}
	return cnt, err
}

func (a *NgingCodeInvitation) GroupBy(keyField string, inputRows ...[]*NgingCodeInvitation) map[string][]*NgingCodeInvitation {
	var rows Slice_NgingCodeInvitation
	if len(inputRows) > 0 {
		rows = Slice_NgingCodeInvitation(inputRows[0])
	} else {
		rows = Slice_NgingCodeInvitation(a.Objects())
	}
	return rows.GroupBy(keyField)
}

func (a *NgingCodeInvitation) KeyBy(keyField string, inputRows ...[]*NgingCodeInvitation) map[string]*NgingCodeInvitation {
	var rows Slice_NgingCodeInvitation
	if len(inputRows) > 0 {
		rows = Slice_NgingCodeInvitation(inputRows[0])
	} else {
		rows = Slice_NgingCodeInvitation(a.Objects())
	}
	return rows.KeyBy(keyField)
}

func (a *NgingCodeInvitation) AsKV(keyField string, valueField string, inputRows ...[]*NgingCodeInvitation) param.Store {
	var rows Slice_NgingCodeInvitation
	if len(inputRows) > 0 {
		rows = Slice_NgingCodeInvitation(inputRows[0])
	} else {
		rows = Slice_NgingCodeInvitation(a.Objects())
	}
	return rows.AsKV(keyField, valueField)
}

func (a *NgingCodeInvitation) ListByOffset(recv interface{}, mw func(db.Result) db.Result, offset, size int, args ...interface{}) (func() int64, error) {
	if recv == nil {
		recv = a.InitObjects()
	}
	if !a.base.Eventable() {
		return a.Param(mw, args...).SetOffset(offset).SetSize(size).SetRecv(recv).List()
	}
	queryParam := a.Param(mw, args...).SetOffset(offset).SetSize(size).SetRecv(recv)
	if err := DBI.FireReading(a, queryParam); err != nil {
		return nil, err
	}
	cnt, err := queryParam.List()
	if err == nil {
		switch v := recv.(type) {
		case *[]*NgingCodeInvitation:
			err = DBI.FireReaded(a, queryParam, Slice_NgingCodeInvitation(*v))
		case []*NgingCodeInvitation:
			err = DBI.FireReaded(a, queryParam, Slice_NgingCodeInvitation(v))
		case factory.Ranger:
			err = DBI.FireReaded(a, queryParam, v)
		}
	}
	return cnt, err
}

func (a *NgingCodeInvitation) Insert() (pk interface{}, err error) {
	a.Created = uint(time.Now().Unix())
	a.Id = 0
	if len(a.Disabled) == 0 {
		a.Disabled = "N"
	}
	if a.base.Eventable() {
		err = DBI.Fire("creating", a, nil)
		if err != nil {
			return
		}
	}
	pk, err = a.Param(nil).SetSend(a).Insert()
	if err == nil && pk != nil {
		if v, y := pk.(uint); y {
			a.Id = v
		} else if v, y := pk.(int64); y {
			a.Id = uint(v)
		}
	}
	if err == nil && a.base.Eventable() {
		err = DBI.Fire("created", a, nil)
	}
	return
}

func (a *NgingCodeInvitation) Update(mw func(db.Result) db.Result, args ...interface{}) (err error) {

	if len(a.Disabled) == 0 {
		a.Disabled = "N"
	}
	if !a.base.Eventable() {
		return a.Param(mw, args...).SetSend(a).Update()
	}
	if err = DBI.Fire("updating", a, mw, args...); err != nil {
		return
	}
	if err = a.Param(mw, args...).SetSend(a).Update(); err != nil {
		return
	}
	return DBI.Fire("updated", a, mw, args...)
}

func (a *NgingCodeInvitation) Updatex(mw func(db.Result) db.Result, args ...interface{}) (affected int64, err error) {

	if len(a.Disabled) == 0 {
		a.Disabled = "N"
	}
	if !a.base.Eventable() {
		return a.Param(mw, args...).SetSend(a).Updatex()
	}
	if err = DBI.Fire("updating", a, mw, args...); err != nil {
		return
	}
	if affected, err = a.Param(mw, args...).SetSend(a).Updatex(); err != nil {
		return
	}
	err = DBI.Fire("updated", a, mw, args...)
	return
}

func (a *NgingCodeInvitation) UpdateByFields(mw func(db.Result) db.Result, fields []string, args ...interface{}) (err error) {

	if len(a.Disabled) == 0 {
		a.Disabled = "N"
	}
	if !a.base.Eventable() {
		return a.Param(mw, args...).UpdateByStruct(a, fields...)
	}
	editColumns := make([]string, len(fields))
	for index, field := range fields {
		editColumns[index] = com.SnakeCase(field)
	}
	if err = DBI.FireUpdate("updating", a, editColumns, mw, args...); err != nil {
		return
	}
	if err = a.Param(mw, args...).UpdateByStruct(a, fields...); err != nil {
		return
	}
	err = DBI.FireUpdate("updated", a, editColumns, mw, args...)
	return
}

func (a *NgingCodeInvitation) UpdatexByFields(mw func(db.Result) db.Result, fields []string, args ...interface{}) (affected int64, err error) {

	if len(a.Disabled) == 0 {
		a.Disabled = "N"
	}
	if !a.base.Eventable() {
		return a.Param(mw, args...).UpdatexByStruct(a, fields...)
	}
	editColumns := make([]string, len(fields))
	for index, field := range fields {
		editColumns[index] = com.SnakeCase(field)
	}
	if err = DBI.FireUpdate("updating", a, editColumns, mw, args...); err != nil {
		return
	}
	if affected, err = a.Param(mw, args...).UpdatexByStruct(a, fields...); err != nil {
		return
	}
	err = DBI.FireUpdate("updated", a, editColumns, mw, args...)
	return
}

func (a *NgingCodeInvitation) UpdateField(mw func(db.Result) db.Result, field string, value interface{}, args ...interface{}) (err error) {
	return a.UpdateFields(mw, map[string]interface{}{
		field: value,
	}, args...)
}

func (a *NgingCodeInvitation) UpdateFields(mw func(db.Result) db.Result, kvset map[string]interface{}, args ...interface{}) (err error) {

	if val, ok := kvset["disabled"]; ok && val != nil {
		if v, ok := val.(string); ok && len(v) == 0 {
			kvset["disabled"] = "N"
		}
	}
	if !a.base.Eventable() {
		return a.Param(mw, args...).SetSend(kvset).Update()
	}
	m := *a
	m.FromRow(kvset)
	var editColumns []string
	for column := range kvset {
		editColumns = append(editColumns, column)
	}
	if err = DBI.FireUpdate("updating", &m, editColumns, mw, args...); err != nil {
		return
	}
	if err = a.Param(mw, args...).SetSend(kvset).Update(); err != nil {
		return
	}
	return DBI.FireUpdate("updated", &m, editColumns, mw, args...)
}

func (a *NgingCodeInvitation) UpdateValues(mw func(db.Result) db.Result, keysValues *db.KeysValues, args ...interface{}) (err error) {
	if !a.base.Eventable() {
		return a.Param(mw, args...).SetSend(keysValues).Update()
	}
	m := *a
	m.FromRow(keysValues.Map())
	if err = DBI.FireUpdate("updating", &m, keysValues.Keys(), mw, args...); err != nil {
		return
	}
	if err = a.Param(mw, args...).SetSend(keysValues).Update(); err != nil {
		return
	}
	return DBI.FireUpdate("updated", &m, keysValues.Keys(), mw, args...)
}

func (a *NgingCodeInvitation) Upsert(mw func(db.Result) db.Result, args ...interface{}) (pk interface{}, err error) {
	pk, err = a.Param(mw, args...).SetSend(a).Upsert(func() error {
		if len(a.Disabled) == 0 {
			a.Disabled = "N"
		}
		if !a.base.Eventable() {
			return nil
		}
		return DBI.Fire("updating", a, mw, args...)
	}, func() error {
		a.Created = uint(time.Now().Unix())
		a.Id = 0
		if len(a.Disabled) == 0 {
			a.Disabled = "N"
		}
		if !a.base.Eventable() {
			return nil
		}
		return DBI.Fire("creating", a, nil)
	})
	if err == nil && pk != nil {
		if v, y := pk.(uint); y {
			a.Id = v
		} else if v, y := pk.(int64); y {
			a.Id = uint(v)
		}
	}
	if err == nil && a.base.Eventable() {
		if pk == nil {
			err = DBI.Fire("updated", a, mw, args...)
		} else {
			err = DBI.Fire("created", a, nil)
		}
	}
	return
}

func (a *NgingCodeInvitation) Delete(mw func(db.Result) db.Result, args ...interface{}) (err error) {

	if !a.base.Eventable() {
		return a.Param(mw, args...).Delete()
	}
	if err = DBI.Fire("deleting", a, mw, args...); err != nil {
		return
	}
	if err = a.Param(mw, args...).Delete(); err != nil {
		return
	}
	return DBI.Fire("deleted", a, mw, args...)
}

func (a *NgingCodeInvitation) Deletex(mw func(db.Result) db.Result, args ...interface{}) (affected int64, err error) {

	if !a.base.Eventable() {
		return a.Param(mw, args...).Deletex()
	}
	if err = DBI.Fire("deleting", a, mw, args...); err != nil {
		return
	}
	if affected, err = a.Param(mw, args...).Deletex(); err != nil {
		return
	}
	err = DBI.Fire("deleted", a, mw, args...)
	return
}

func (a *NgingCodeInvitation) Count(mw func(db.Result) db.Result, args ...interface{}) (int64, error) {
	return a.Param(mw, args...).Count()
}

func (a *NgingCodeInvitation) Exists(mw func(db.Result) db.Result, args ...interface{}) (bool, error) {
	return a.Param(mw, args...).Exists()
}

func (a *NgingCodeInvitation) Reset() *NgingCodeInvitation {
	a.Id = 0
	a.Uid = 0
	a.RecvUid = 0
	a.Code = ``
	a.Created = 0
	a.Used = 0
	a.Start = 0
	a.End = 0
	a.Disabled = ``
	a.RoleIds = ``
	return a
}

func (a *NgingCodeInvitation) AsMap(onlyFields ...string) param.Store {
	r := param.Store{}
	if len(onlyFields) == 0 {
		r["Id"] = a.Id
		r["Uid"] = a.Uid
		r["RecvUid"] = a.RecvUid
		r["Code"] = a.Code
		r["Created"] = a.Created
		r["Used"] = a.Used
		r["Start"] = a.Start
		r["End"] = a.End
		r["Disabled"] = a.Disabled
		r["RoleIds"] = a.RoleIds
		return r
	}
	for _, field := range onlyFields {
		switch field {
		case "Id":
			r["Id"] = a.Id
		case "Uid":
			r["Uid"] = a.Uid
		case "RecvUid":
			r["RecvUid"] = a.RecvUid
		case "Code":
			r["Code"] = a.Code
		case "Created":
			r["Created"] = a.Created
		case "Used":
			r["Used"] = a.Used
		case "Start":
			r["Start"] = a.Start
		case "End":
			r["End"] = a.End
		case "Disabled":
			r["Disabled"] = a.Disabled
		case "RoleIds":
			r["RoleIds"] = a.RoleIds
		}
	}
	return r
}

func (a *NgingCodeInvitation) FromRow(row map[string]interface{}) {
	for key, value := range row {
		switch key {
		case "id":
			a.Id = param.AsUint(value)
		case "uid":
			a.Uid = param.AsUint(value)
		case "recv_uid":
			a.RecvUid = param.AsUint(value)
		case "code":
			a.Code = param.AsString(value)
		case "created":
			a.Created = param.AsUint(value)
		case "used":
			a.Used = param.AsUint(value)
		case "start":
			a.Start = param.AsUint(value)
		case "end":
			a.End = param.AsUint(value)
		case "disabled":
			a.Disabled = param.AsString(value)
		case "role_ids":
			a.RoleIds = param.AsString(value)
		}
	}
}

func (a *NgingCodeInvitation) Set(key interface{}, value ...interface{}) {
	switch k := key.(type) {
	case map[string]interface{}:
		for kk, vv := range k {
			a.Set(kk, vv)
		}
	default:
		var (
			kk string
			vv interface{}
		)
		if k, y := key.(string); y {
			kk = k
		} else {
			kk = fmt.Sprint(key)
		}
		if len(value) > 0 {
			vv = value[0]
		}
		switch kk {
		case "Id":
			a.Id = param.AsUint(vv)
		case "Uid":
			a.Uid = param.AsUint(vv)
		case "RecvUid":
			a.RecvUid = param.AsUint(vv)
		case "Code":
			a.Code = param.AsString(vv)
		case "Created":
			a.Created = param.AsUint(vv)
		case "Used":
			a.Used = param.AsUint(vv)
		case "Start":
			a.Start = param.AsUint(vv)
		case "End":
			a.End = param.AsUint(vv)
		case "Disabled":
			a.Disabled = param.AsString(vv)
		case "RoleIds":
			a.RoleIds = param.AsString(vv)
		}
	}
}

func (a *NgingCodeInvitation) AsRow(onlyFields ...string) param.Store {
	r := param.Store{}
	if len(onlyFields) == 0 {
		r["id"] = a.Id
		r["uid"] = a.Uid
		r["recv_uid"] = a.RecvUid
		r["code"] = a.Code
		r["created"] = a.Created
		r["used"] = a.Used
		r["start"] = a.Start
		r["end"] = a.End
		r["disabled"] = a.Disabled
		r["role_ids"] = a.RoleIds
		return r
	}
	for _, field := range onlyFields {
		switch field {
		case "id":
			r["id"] = a.Id
		case "uid":
			r["uid"] = a.Uid
		case "recv_uid":
			r["recv_uid"] = a.RecvUid
		case "code":
			r["code"] = a.Code
		case "created":
			r["created"] = a.Created
		case "used":
			r["used"] = a.Used
		case "start":
			r["start"] = a.Start
		case "end":
			r["end"] = a.End
		case "disabled":
			r["disabled"] = a.Disabled
		case "role_ids":
			r["role_ids"] = a.RoleIds
		}
	}
	return r
}

func (a *NgingCodeInvitation) ListPage(cond *db.Compounds, sorts ...interface{}) error {
	_, err := pagination.NewLister(a, nil, func(r db.Result) db.Result {
		return r.OrderBy(sorts...)
	}, cond.And()).Paging(a.Context())
	return err
}

func (a *NgingCodeInvitation) ListPageAs(recv interface{}, cond *db.Compounds, sorts ...interface{}) error {
	_, err := pagination.NewLister(a, recv, func(r db.Result) db.Result {
		return r.OrderBy(sorts...)
	}, cond.And()).Paging(a.Context())
	return err
}

func (a *NgingCodeInvitation) BatchValidate(kvset map[string]interface{}) error {
	if kvset == nil {
		kvset = a.AsRow()
	}
	return DBI.Fields.BatchValidate(a.Short_(), kvset)
}

func (a *NgingCodeInvitation) Validate(field string, value interface{}) error {
	return DBI.Fields.Validate(a.Short_(), field, value)
}
