// @generated Do not edit this file, which is automatically generated by the generator.

package dbschema

import (
	"fmt"

	"time"

	"github.com/webx-top/com"
	"github.com/webx-top/db"
	"github.com/webx-top/db/lib/factory"
	"github.com/webx-top/db/lib/factory/pagination"
	"github.com/webx-top/echo"
	"github.com/webx-top/echo/param"
)

type Slice_NgingLoginLog []*NgingLoginLog

func (s Slice_NgingLoginLog) Range(fn func(m factory.Model) error) error {
	for _, v := range s {
		if err := fn(v); err != nil {
			return err
		}
	}
	return nil
}

func (s Slice_NgingLoginLog) RangeRaw(fn func(m *NgingLoginLog) error) error {
	for _, v := range s {
		if err := fn(v); err != nil {
			return err
		}
	}
	return nil
}

func (s Slice_NgingLoginLog) GroupBy(keyField string) map[string][]*NgingLoginLog {
	r := map[string][]*NgingLoginLog{}
	for _, row := range s {
		dmap := row.AsMap()
		vkey := fmt.Sprint(dmap[keyField])
		if _, y := r[vkey]; !y {
			r[vkey] = []*NgingLoginLog{}
		}
		r[vkey] = append(r[vkey], row)
	}
	return r
}

func (s Slice_NgingLoginLog) KeyBy(keyField string) map[string]*NgingLoginLog {
	r := map[string]*NgingLoginLog{}
	for _, row := range s {
		dmap := row.AsMap()
		vkey := fmt.Sprint(dmap[keyField])
		r[vkey] = row
	}
	return r
}

func (s Slice_NgingLoginLog) AsKV(keyField string, valueField string) param.Store {
	r := param.Store{}
	for _, row := range s {
		dmap := row.AsMap()
		vkey := fmt.Sprint(dmap[keyField])
		r[vkey] = dmap[valueField]
	}
	return r
}

func (s Slice_NgingLoginLog) Transform(transfers map[string]param.Transfer) []param.Store {
	r := make([]param.Store, len(s))
	for idx, row := range s {
		r[idx] = row.AsMap().Transform(transfers)
	}
	return r
}

func (s Slice_NgingLoginLog) FromList(data interface{}) Slice_NgingLoginLog {
	values, ok := data.([]*NgingLoginLog)
	if !ok {
		for _, value := range data.([]interface{}) {
			row := &NgingLoginLog{}
			row.FromRow(value.(map[string]interface{}))
			s = append(s, row)
		}
		return s
	}
	s = append(s, values...)

	return s
}

func NewNgingLoginLog(ctx echo.Context) *NgingLoginLog {
	m := &NgingLoginLog{}
	m.SetContext(ctx)
	return m
}

// NgingLoginLog 登录日志
type NgingLoginLog struct {
	base    factory.Base
	objects []*NgingLoginLog

	OwnerType  string `db:"owner_type" bson:"owner_type" comment:"用户类型(user-后台用户;customer-前台客户)" json:"owner_type" xml:"owner_type"`
	OwnerId    uint64 `db:"owner_id" bson:"owner_id" comment:"用户ID" json:"owner_id" xml:"owner_id"`
	SessionId  string `db:"session_id" bson:"session_id" comment:"session id" json:"session_id" xml:"session_id"`
	Username   string `db:"username" bson:"username" comment:"登录名" json:"username" xml:"username"`
	Errpwd     string `db:"errpwd" bson:"errpwd" comment:"错误密码" json:"errpwd" xml:"errpwd"`
	IpAddress  string `db:"ip_address" bson:"ip_address" comment:"ip地址" json:"ip_address" xml:"ip_address"`
	IpLocation string `db:"ip_location" bson:"ip_location" comment:"ip定位" json:"ip_location" xml:"ip_location"`
	UserAgent  string `db:"user_agent" bson:"user_agent" comment:"浏览器代理" json:"user_agent" xml:"user_agent"`
	Success    string `db:"success" bson:"success" comment:"是否登录成功" json:"success" xml:"success"`
	Failmsg    string `db:"failmsg" bson:"failmsg" comment:"失败信息" json:"failmsg" xml:"failmsg"`
	Day        uint   `db:"day" bson:"day" comment:"日期(Ymd)" json:"day" xml:"day"`
	Created    uint   `db:"created" bson:"created" comment:"创建时间" json:"created" xml:"created"`
}

// - base function

func (a *NgingLoginLog) Trans() *factory.Transaction {
	return a.base.Trans()
}

func (a *NgingLoginLog) Use(trans *factory.Transaction) factory.Model {
	a.base.Use(trans)
	return a
}

func (a *NgingLoginLog) SetContext(ctx echo.Context) factory.Model {
	a.base.SetContext(ctx)
	return a
}

func (a *NgingLoginLog) EventON(on ...bool) factory.Model {
	a.base.EventON(on...)
	return a
}

func (a *NgingLoginLog) EventOFF(off ...bool) factory.Model {
	a.base.EventOFF(off...)
	return a
}

func (a *NgingLoginLog) Context() echo.Context {
	return a.base.Context()
}

func (a *NgingLoginLog) SetConnID(connID int) factory.Model {
	a.base.SetConnID(connID)
	return a
}

func (a *NgingLoginLog) SetNamer(namer func(factory.Model) string) factory.Model {
	a.base.SetNamer(namer)
	return a
}

func (a *NgingLoginLog) Namer() func(factory.Model) string {
	return a.base.Namer()
}

func (a *NgingLoginLog) SetParam(param *factory.Param) factory.Model {
	a.base.SetParam(param)
	return a
}

func (a *NgingLoginLog) Param(mw func(db.Result) db.Result, args ...interface{}) *factory.Param {
	if a.base.Param() == nil {
		return a.NewParam().SetMiddleware(mw).SetArgs(args...)
	}
	return a.base.Param().SetMiddleware(mw).SetArgs(args...)
}

// - current function

func (a *NgingLoginLog) New(structName string, connID ...int) factory.Model {
	if len(connID) > 0 {
		return factory.NewModel(structName, connID[0]).Use(a.base.Trans())
	}
	return factory.NewModel(structName, a.base.ConnID()).Use(a.base.Trans())
}

func (a *NgingLoginLog) Objects() []*NgingLoginLog {
	if a.objects == nil {
		return nil
	}
	return a.objects[:]
}

func (a *NgingLoginLog) XObjects() Slice_NgingLoginLog {
	return Slice_NgingLoginLog(a.Objects())
}

func (a *NgingLoginLog) NewObjects() factory.Ranger {
	return &Slice_NgingLoginLog{}
}

func (a *NgingLoginLog) InitObjects() *[]*NgingLoginLog {
	a.objects = []*NgingLoginLog{}
	return &a.objects
}

func (a *NgingLoginLog) NewParam() *factory.Param {
	return factory.NewParam(factory.DefaultFactory).SetIndex(a.base.ConnID()).SetTrans(a.base.Trans()).SetCollection(a.Name_()).SetModel(a)
}

func (a *NgingLoginLog) Short_() string {
	return "nging_login_log"
}

func (a *NgingLoginLog) Struct_() string {
	return "NgingLoginLog"
}

func (a *NgingLoginLog) Name_() string {
	if a.base.Namer() != nil {
		return WithPrefix(a.base.Namer()(a))
	}
	return WithPrefix(factory.TableNamerGet(a.Short_())(a))
}

func (a *NgingLoginLog) CPAFrom(source factory.Model) factory.Model {
	a.SetContext(source.Context())
	a.Use(source.Trans())
	a.SetNamer(source.Namer())
	return a
}

func (a *NgingLoginLog) Get(mw func(db.Result) db.Result, args ...interface{}) (err error) {
	base := a.base
	if !a.base.Eventable() {
		err = a.Param(mw, args...).SetRecv(a).One()
		a.base = base
		return
	}
	queryParam := a.Param(mw, args...).SetRecv(a)
	if err = DBI.FireReading(a, queryParam); err != nil {
		return
	}
	err = queryParam.One()
	a.base = base
	if err == nil {
		err = DBI.FireReaded(a, queryParam)
	}
	return
}

func (a *NgingLoginLog) List(recv interface{}, mw func(db.Result) db.Result, page, size int, args ...interface{}) (func() int64, error) {
	if recv == nil {
		recv = a.InitObjects()
	}
	if !a.base.Eventable() {
		return a.Param(mw, args...).SetPage(page).SetSize(size).SetRecv(recv).List()
	}
	queryParam := a.Param(mw, args...).SetPage(page).SetSize(size).SetRecv(recv)
	if err := DBI.FireReading(a, queryParam); err != nil {
		return nil, err
	}
	cnt, err := queryParam.List()
	if err == nil {
		switch v := recv.(type) {
		case *[]*NgingLoginLog:
			err = DBI.FireReaded(a, queryParam, Slice_NgingLoginLog(*v))
		case []*NgingLoginLog:
			err = DBI.FireReaded(a, queryParam, Slice_NgingLoginLog(v))
		case factory.Ranger:
			err = DBI.FireReaded(a, queryParam, v)
		}
	}
	return cnt, err
}

func (a *NgingLoginLog) GroupBy(keyField string, inputRows ...[]*NgingLoginLog) map[string][]*NgingLoginLog {
	var rows Slice_NgingLoginLog
	if len(inputRows) > 0 {
		rows = Slice_NgingLoginLog(inputRows[0])
	} else {
		rows = Slice_NgingLoginLog(a.Objects())
	}
	return rows.GroupBy(keyField)
}

func (a *NgingLoginLog) KeyBy(keyField string, inputRows ...[]*NgingLoginLog) map[string]*NgingLoginLog {
	var rows Slice_NgingLoginLog
	if len(inputRows) > 0 {
		rows = Slice_NgingLoginLog(inputRows[0])
	} else {
		rows = Slice_NgingLoginLog(a.Objects())
	}
	return rows.KeyBy(keyField)
}

func (a *NgingLoginLog) AsKV(keyField string, valueField string, inputRows ...[]*NgingLoginLog) param.Store {
	var rows Slice_NgingLoginLog
	if len(inputRows) > 0 {
		rows = Slice_NgingLoginLog(inputRows[0])
	} else {
		rows = Slice_NgingLoginLog(a.Objects())
	}
	return rows.AsKV(keyField, valueField)
}

func (a *NgingLoginLog) ListByOffset(recv interface{}, mw func(db.Result) db.Result, offset, size int, args ...interface{}) (func() int64, error) {
	if recv == nil {
		recv = a.InitObjects()
	}
	if !a.base.Eventable() {
		return a.Param(mw, args...).SetOffset(offset).SetSize(size).SetRecv(recv).List()
	}
	queryParam := a.Param(mw, args...).SetOffset(offset).SetSize(size).SetRecv(recv)
	if err := DBI.FireReading(a, queryParam); err != nil {
		return nil, err
	}
	cnt, err := queryParam.List()
	if err == nil {
		switch v := recv.(type) {
		case *[]*NgingLoginLog:
			err = DBI.FireReaded(a, queryParam, Slice_NgingLoginLog(*v))
		case []*NgingLoginLog:
			err = DBI.FireReaded(a, queryParam, Slice_NgingLoginLog(v))
		case factory.Ranger:
			err = DBI.FireReaded(a, queryParam, v)
		}
	}
	return cnt, err
}

func (a *NgingLoginLog) Insert() (pk interface{}, err error) {
	a.Created = uint(time.Now().Unix())
	if len(a.OwnerType) == 0 {
		a.OwnerType = "user"
	}
	if len(a.Success) == 0 {
		a.Success = "N"
	}
	if a.base.Eventable() {
		err = DBI.Fire("creating", a, nil)
		if err != nil {
			return
		}
	}
	pk, err = a.Param(nil).SetSend(a).Insert()

	if err == nil && a.base.Eventable() {
		err = DBI.Fire("created", a, nil)
	}
	return
}

func (a *NgingLoginLog) Update(mw func(db.Result) db.Result, args ...interface{}) (err error) {

	if len(a.OwnerType) == 0 {
		a.OwnerType = "user"
	}
	if len(a.Success) == 0 {
		a.Success = "N"
	}
	if !a.base.Eventable() {
		return a.Param(mw, args...).SetSend(a).Update()
	}
	if err = DBI.Fire("updating", a, mw, args...); err != nil {
		return
	}
	if err = a.Param(mw, args...).SetSend(a).Update(); err != nil {
		return
	}
	return DBI.Fire("updated", a, mw, args...)
}

func (a *NgingLoginLog) Updatex(mw func(db.Result) db.Result, args ...interface{}) (affected int64, err error) {

	if len(a.OwnerType) == 0 {
		a.OwnerType = "user"
	}
	if len(a.Success) == 0 {
		a.Success = "N"
	}
	if !a.base.Eventable() {
		return a.Param(mw, args...).SetSend(a).Updatex()
	}
	if err = DBI.Fire("updating", a, mw, args...); err != nil {
		return
	}
	if affected, err = a.Param(mw, args...).SetSend(a).Updatex(); err != nil {
		return
	}
	err = DBI.Fire("updated", a, mw, args...)
	return
}

func (a *NgingLoginLog) UpdateByFields(mw func(db.Result) db.Result, fields []string, args ...interface{}) (err error) {

	if len(a.OwnerType) == 0 {
		a.OwnerType = "user"
	}
	if len(a.Success) == 0 {
		a.Success = "N"
	}
	if !a.base.Eventable() {
		return a.Param(mw, args...).UpdateByStruct(a, fields...)
	}
	editColumns := make([]string, len(fields))
	for index, field := range fields {
		editColumns[index] = com.SnakeCase(field)
	}
	if err = DBI.FireUpdate("updating", a, editColumns, mw, args...); err != nil {
		return
	}
	if err = a.Param(mw, args...).UpdateByStruct(a, fields...); err != nil {
		return
	}
	err = DBI.FireUpdate("updated", a, editColumns, mw, args...)
	return
}

func (a *NgingLoginLog) UpdatexByFields(mw func(db.Result) db.Result, fields []string, args ...interface{}) (affected int64, err error) {

	if len(a.OwnerType) == 0 {
		a.OwnerType = "user"
	}
	if len(a.Success) == 0 {
		a.Success = "N"
	}
	if !a.base.Eventable() {
		return a.Param(mw, args...).UpdatexByStruct(a, fields...)
	}
	editColumns := make([]string, len(fields))
	for index, field := range fields {
		editColumns[index] = com.SnakeCase(field)
	}
	if err = DBI.FireUpdate("updating", a, editColumns, mw, args...); err != nil {
		return
	}
	if affected, err = a.Param(mw, args...).UpdatexByStruct(a, fields...); err != nil {
		return
	}
	err = DBI.FireUpdate("updated", a, editColumns, mw, args...)
	return
}

func (a *NgingLoginLog) UpdateField(mw func(db.Result) db.Result, field string, value interface{}, args ...interface{}) (err error) {
	return a.UpdateFields(mw, map[string]interface{}{
		field: value,
	}, args...)
}

func (a *NgingLoginLog) UpdateFields(mw func(db.Result) db.Result, kvset map[string]interface{}, args ...interface{}) (err error) {

	if val, ok := kvset["owner_type"]; ok && val != nil {
		if v, ok := val.(string); ok && len(v) == 0 {
			kvset["owner_type"] = "user"
		}
	}
	if val, ok := kvset["success"]; ok && val != nil {
		if v, ok := val.(string); ok && len(v) == 0 {
			kvset["success"] = "N"
		}
	}
	if !a.base.Eventable() {
		return a.Param(mw, args...).SetSend(kvset).Update()
	}
	m := *a
	m.FromRow(kvset)
	var editColumns []string
	for column := range kvset {
		editColumns = append(editColumns, column)
	}
	if err = DBI.FireUpdate("updating", &m, editColumns, mw, args...); err != nil {
		return
	}
	if err = a.Param(mw, args...).SetSend(kvset).Update(); err != nil {
		return
	}
	return DBI.FireUpdate("updated", &m, editColumns, mw, args...)
}

func (a *NgingLoginLog) UpdateValues(mw func(db.Result) db.Result, keysValues *db.KeysValues, args ...interface{}) (err error) {
	if !a.base.Eventable() {
		return a.Param(mw, args...).SetSend(keysValues).Update()
	}
	m := *a
	m.FromRow(keysValues.Map())
	if err = DBI.FireUpdate("updating", &m, keysValues.Keys(), mw, args...); err != nil {
		return
	}
	if err = a.Param(mw, args...).SetSend(keysValues).Update(); err != nil {
		return
	}
	return DBI.FireUpdate("updated", &m, keysValues.Keys(), mw, args...)
}

func (a *NgingLoginLog) Upsert(mw func(db.Result) db.Result, args ...interface{}) (pk interface{}, err error) {
	pk, err = a.Param(mw, args...).SetSend(a).Upsert(func() error {
		if len(a.OwnerType) == 0 {
			a.OwnerType = "user"
		}
		if len(a.Success) == 0 {
			a.Success = "N"
		}
		if !a.base.Eventable() {
			return nil
		}
		return DBI.Fire("updating", a, mw, args...)
	}, func() error {
		a.Created = uint(time.Now().Unix())
		if len(a.OwnerType) == 0 {
			a.OwnerType = "user"
		}
		if len(a.Success) == 0 {
			a.Success = "N"
		}
		if !a.base.Eventable() {
			return nil
		}
		return DBI.Fire("creating", a, nil)
	})

	if err == nil && a.base.Eventable() {
		if pk == nil {
			err = DBI.Fire("updated", a, mw, args...)
		} else {
			err = DBI.Fire("created", a, nil)
		}
	}
	return
}

func (a *NgingLoginLog) Delete(mw func(db.Result) db.Result, args ...interface{}) (err error) {

	if !a.base.Eventable() {
		return a.Param(mw, args...).Delete()
	}
	if err = DBI.Fire("deleting", a, mw, args...); err != nil {
		return
	}
	if err = a.Param(mw, args...).Delete(); err != nil {
		return
	}
	return DBI.Fire("deleted", a, mw, args...)
}

func (a *NgingLoginLog) Deletex(mw func(db.Result) db.Result, args ...interface{}) (affected int64, err error) {

	if !a.base.Eventable() {
		return a.Param(mw, args...).Deletex()
	}
	if err = DBI.Fire("deleting", a, mw, args...); err != nil {
		return
	}
	if affected, err = a.Param(mw, args...).Deletex(); err != nil {
		return
	}
	err = DBI.Fire("deleted", a, mw, args...)
	return
}

func (a *NgingLoginLog) Count(mw func(db.Result) db.Result, args ...interface{}) (int64, error) {
	return a.Param(mw, args...).Count()
}

func (a *NgingLoginLog) Exists(mw func(db.Result) db.Result, args ...interface{}) (bool, error) {
	return a.Param(mw, args...).Exists()
}

func (a *NgingLoginLog) Reset() *NgingLoginLog {
	a.OwnerType = ``
	a.OwnerId = 0
	a.SessionId = ``
	a.Username = ``
	a.Errpwd = ``
	a.IpAddress = ``
	a.IpLocation = ``
	a.UserAgent = ``
	a.Success = ``
	a.Failmsg = ``
	a.Day = 0
	a.Created = 0
	return a
}

func (a *NgingLoginLog) AsMap(onlyFields ...string) param.Store {
	r := param.Store{}
	if len(onlyFields) == 0 {
		r["OwnerType"] = a.OwnerType
		r["OwnerId"] = a.OwnerId
		r["SessionId"] = a.SessionId
		r["Username"] = a.Username
		r["Errpwd"] = a.Errpwd
		r["IpAddress"] = a.IpAddress
		r["IpLocation"] = a.IpLocation
		r["UserAgent"] = a.UserAgent
		r["Success"] = a.Success
		r["Failmsg"] = a.Failmsg
		r["Day"] = a.Day
		r["Created"] = a.Created
		return r
	}
	for _, field := range onlyFields {
		switch field {
		case "OwnerType":
			r["OwnerType"] = a.OwnerType
		case "OwnerId":
			r["OwnerId"] = a.OwnerId
		case "SessionId":
			r["SessionId"] = a.SessionId
		case "Username":
			r["Username"] = a.Username
		case "Errpwd":
			r["Errpwd"] = a.Errpwd
		case "IpAddress":
			r["IpAddress"] = a.IpAddress
		case "IpLocation":
			r["IpLocation"] = a.IpLocation
		case "UserAgent":
			r["UserAgent"] = a.UserAgent
		case "Success":
			r["Success"] = a.Success
		case "Failmsg":
			r["Failmsg"] = a.Failmsg
		case "Day":
			r["Day"] = a.Day
		case "Created":
			r["Created"] = a.Created
		}
	}
	return r
}

func (a *NgingLoginLog) FromRow(row map[string]interface{}) {
	for key, value := range row {
		switch key {
		case "owner_type":
			a.OwnerType = param.AsString(value)
		case "owner_id":
			a.OwnerId = param.AsUint64(value)
		case "session_id":
			a.SessionId = param.AsString(value)
		case "username":
			a.Username = param.AsString(value)
		case "errpwd":
			a.Errpwd = param.AsString(value)
		case "ip_address":
			a.IpAddress = param.AsString(value)
		case "ip_location":
			a.IpLocation = param.AsString(value)
		case "user_agent":
			a.UserAgent = param.AsString(value)
		case "success":
			a.Success = param.AsString(value)
		case "failmsg":
			a.Failmsg = param.AsString(value)
		case "day":
			a.Day = param.AsUint(value)
		case "created":
			a.Created = param.AsUint(value)
		}
	}
}

func (a *NgingLoginLog) Set(key interface{}, value ...interface{}) {
	switch k := key.(type) {
	case map[string]interface{}:
		for kk, vv := range k {
			a.Set(kk, vv)
		}
	default:
		var (
			kk string
			vv interface{}
		)
		if k, y := key.(string); y {
			kk = k
		} else {
			kk = fmt.Sprint(key)
		}
		if len(value) > 0 {
			vv = value[0]
		}
		switch kk {
		case "OwnerType":
			a.OwnerType = param.AsString(vv)
		case "OwnerId":
			a.OwnerId = param.AsUint64(vv)
		case "SessionId":
			a.SessionId = param.AsString(vv)
		case "Username":
			a.Username = param.AsString(vv)
		case "Errpwd":
			a.Errpwd = param.AsString(vv)
		case "IpAddress":
			a.IpAddress = param.AsString(vv)
		case "IpLocation":
			a.IpLocation = param.AsString(vv)
		case "UserAgent":
			a.UserAgent = param.AsString(vv)
		case "Success":
			a.Success = param.AsString(vv)
		case "Failmsg":
			a.Failmsg = param.AsString(vv)
		case "Day":
			a.Day = param.AsUint(vv)
		case "Created":
			a.Created = param.AsUint(vv)
		}
	}
}

func (a *NgingLoginLog) AsRow(onlyFields ...string) param.Store {
	r := param.Store{}
	if len(onlyFields) == 0 {
		r["owner_type"] = a.OwnerType
		r["owner_id"] = a.OwnerId
		r["session_id"] = a.SessionId
		r["username"] = a.Username
		r["errpwd"] = a.Errpwd
		r["ip_address"] = a.IpAddress
		r["ip_location"] = a.IpLocation
		r["user_agent"] = a.UserAgent
		r["success"] = a.Success
		r["failmsg"] = a.Failmsg
		r["day"] = a.Day
		r["created"] = a.Created
		return r
	}
	for _, field := range onlyFields {
		switch field {
		case "owner_type":
			r["owner_type"] = a.OwnerType
		case "owner_id":
			r["owner_id"] = a.OwnerId
		case "session_id":
			r["session_id"] = a.SessionId
		case "username":
			r["username"] = a.Username
		case "errpwd":
			r["errpwd"] = a.Errpwd
		case "ip_address":
			r["ip_address"] = a.IpAddress
		case "ip_location":
			r["ip_location"] = a.IpLocation
		case "user_agent":
			r["user_agent"] = a.UserAgent
		case "success":
			r["success"] = a.Success
		case "failmsg":
			r["failmsg"] = a.Failmsg
		case "day":
			r["day"] = a.Day
		case "created":
			r["created"] = a.Created
		}
	}
	return r
}

func (a *NgingLoginLog) ListPage(cond *db.Compounds, sorts ...interface{}) error {
	_, err := pagination.NewLister(a, nil, func(r db.Result) db.Result {
		return r.OrderBy(sorts...)
	}, cond.And()).Paging(a.Context())
	return err
}

func (a *NgingLoginLog) ListPageAs(recv interface{}, cond *db.Compounds, sorts ...interface{}) error {
	_, err := pagination.NewLister(a, recv, func(r db.Result) db.Result {
		return r.OrderBy(sorts...)
	}, cond.And()).Paging(a.Context())
	return err
}

func (a *NgingLoginLog) BatchValidate(kvset map[string]interface{}) error {
	if kvset == nil {
		kvset = a.AsRow()
	}
	return DBI.Fields.BatchValidate(a.Short_(), kvset)
}

func (a *NgingLoginLog) Validate(field string, value interface{}) error {
	return DBI.Fields.Validate(a.Short_(), field, value)
}
