// @generated Do not edit this file, which is automatically generated by the generator.

package dbschema

import (
	"fmt"

	"time"

	"github.com/webx-top/com"
	"github.com/webx-top/db"
	"github.com/webx-top/db/lib/factory"
	"github.com/webx-top/db/lib/factory/pagination"
	"github.com/webx-top/echo"
	"github.com/webx-top/echo/param"
)

type Slice_NgingAccessLog []*NgingAccessLog

func (s Slice_NgingAccessLog) Range(fn func(m factory.Model) error) error {
	for _, v := range s {
		if err := fn(v); err != nil {
			return err
		}
	}
	return nil
}

func (s Slice_NgingAccessLog) RangeRaw(fn func(m *NgingAccessLog) error) error {
	for _, v := range s {
		if err := fn(v); err != nil {
			return err
		}
	}
	return nil
}

func (s Slice_NgingAccessLog) GroupBy(keyField string) map[string][]*NgingAccessLog {
	r := map[string][]*NgingAccessLog{}
	for _, row := range s {
		dmap := row.AsMap()
		vkey := fmt.Sprint(dmap[keyField])
		if _, y := r[vkey]; !y {
			r[vkey] = []*NgingAccessLog{}
		}
		r[vkey] = append(r[vkey], row)
	}
	return r
}

func (s Slice_NgingAccessLog) KeyBy(keyField string) map[string]*NgingAccessLog {
	r := map[string]*NgingAccessLog{}
	for _, row := range s {
		dmap := row.AsMap()
		vkey := fmt.Sprint(dmap[keyField])
		r[vkey] = row
	}
	return r
}

func (s Slice_NgingAccessLog) AsKV(keyField string, valueField string) param.Store {
	r := param.Store{}
	for _, row := range s {
		dmap := row.AsMap()
		vkey := fmt.Sprint(dmap[keyField])
		r[vkey] = dmap[valueField]
	}
	return r
}

func (s Slice_NgingAccessLog) Transform(transfers map[string]param.Transfer) []param.Store {
	r := make([]param.Store, len(s))
	for idx, row := range s {
		r[idx] = row.AsMap().Transform(transfers)
	}
	return r
}

func (s Slice_NgingAccessLog) FromList(data interface{}) Slice_NgingAccessLog {
	values, ok := data.([]*NgingAccessLog)
	if !ok {
		for _, value := range data.([]interface{}) {
			row := &NgingAccessLog{}
			row.FromRow(value.(map[string]interface{}))
			s = append(s, row)
		}
		return s
	}
	s = append(s, values...)

	return s
}

func NewNgingAccessLog(ctx echo.Context) *NgingAccessLog {
	m := &NgingAccessLog{}
	m.SetContext(ctx)
	return m
}

// NgingAccessLog
type NgingAccessLog struct {
	base    factory.Base
	objects []*NgingAccessLog

	Id          uint64  `db:"id,omitempty,pk" bson:"id,omitempty" comment:"ID" json:"id" xml:"id"`
	VhostId     uint    `db:"vhost_id" bson:"vhost_id" comment:"虚拟主机ID" json:"vhost_id" xml:"vhost_id"`
	RemoteAddr  string  `db:"remote_addr" bson:"remote_addr" comment:"IP地址" json:"remote_addr" xml:"remote_addr"`
	XRealIp     string  `db:"x_real_ip" bson:"x_real_ip" comment:"IP" json:"x_real_ip" xml:"x_real_ip"`
	XForwardFor string  `db:"x_forward_for" bson:"x_forward_for" comment:"IP" json:"x_forward_for" xml:"x_forward_for"`
	LocalAddr   string  `db:"local_addr" bson:"local_addr" comment:"本机地址" json:"local_addr" xml:"local_addr"`
	Elapsed     float64 `db:"elapsed" bson:"elapsed" comment:"耗时(秒)" json:"elapsed" xml:"elapsed"`
	Host        string  `db:"host" bson:"host" comment:"Header中的Host, 一般会是域名" json:"host" xml:"host"`
	User        string  `db:"user" bson:"user" comment:"用户" json:"user" xml:"user"`
	TimeLocal   string  `db:"time_local" bson:"time_local" comment:"本地时间格式" json:"time_local" xml:"time_local"`
	Minute      string  `db:"minute" bson:"minute" comment:"H:i" json:"minute" xml:"minute"`
	Method      string  `db:"method" bson:"method" comment:"GET POST HEAD OPTIONS PUT DELETE..." json:"method" xml:"method"`
	Uri         string  `db:"uri" bson:"uri" comment:"网址" json:"uri" xml:"uri"`
	Version     string  `db:"version" bson:"version" comment:"HTTP/1.0, HTTP/1.1 ..." json:"version" xml:"version"`
	StatusCode  uint    `db:"status_code" bson:"status_code" comment:"状态码" json:"status_code" xml:"status_code"`
	BodyBytes   uint64  `db:"body_bytes" bson:"body_bytes" comment:"响应body字节数" json:"body_bytes" xml:"body_bytes"`
	Referer     string  `db:"referer" bson:"referer" comment:"来源网址" json:"referer" xml:"referer"`
	UserAgent   string  `db:"user_agent" bson:"user_agent" comment:"用户代理" json:"user_agent" xml:"user_agent"`
	HitStatus   uint    `db:"hit_status" bson:"hit_status" comment:"缓存服务器命中状态" json:"hit_status" xml:"hit_status"`
	Scheme      string  `db:"scheme" bson:"scheme" comment:"https/http" json:"scheme" xml:"scheme"`
	BrowerName  string  `db:"brower_name" bson:"brower_name" comment:"浏览器名" json:"brower_name" xml:"brower_name"`
	BrowerType  string  `db:"brower_type" bson:"brower_type" comment:"浏览器类型(spider/mobile/pc)" json:"brower_type" xml:"brower_type"`
	Created     uint    `db:"created" bson:"created" comment:"创建时间" json:"created" xml:"created"`
}

// - base function

func (a *NgingAccessLog) Trans() *factory.Transaction {
	return a.base.Trans()
}

func (a *NgingAccessLog) Use(trans *factory.Transaction) factory.Model {
	a.base.Use(trans)
	return a
}

func (a *NgingAccessLog) SetContext(ctx echo.Context) factory.Model {
	a.base.SetContext(ctx)
	return a
}

func (a *NgingAccessLog) EventON(on ...bool) factory.Model {
	a.base.EventON(on...)
	return a
}

func (a *NgingAccessLog) EventOFF(off ...bool) factory.Model {
	a.base.EventOFF(off...)
	return a
}

func (a *NgingAccessLog) Context() echo.Context {
	return a.base.Context()
}

func (a *NgingAccessLog) SetConnID(connID int) factory.Model {
	a.base.SetConnID(connID)
	return a
}

func (a *NgingAccessLog) SetNamer(namer func(factory.Model) string) factory.Model {
	a.base.SetNamer(namer)
	return a
}

func (a *NgingAccessLog) Namer() func(factory.Model) string {
	return a.base.Namer()
}

func (a *NgingAccessLog) SetParam(param *factory.Param) factory.Model {
	a.base.SetParam(param)
	return a
}

func (a *NgingAccessLog) Param(mw func(db.Result) db.Result, args ...interface{}) *factory.Param {
	if a.base.Param() == nil {
		return a.NewParam().SetMiddleware(mw).SetArgs(args...)
	}
	return a.base.Param().SetMiddleware(mw).SetArgs(args...)
}

// - current function

func (a *NgingAccessLog) New(structName string, connID ...int) factory.Model {
	if len(connID) > 0 {
		return factory.NewModel(structName, connID[0]).Use(a.base.Trans())
	}
	return factory.NewModel(structName, a.base.ConnID()).Use(a.base.Trans())
}

func (a *NgingAccessLog) Objects() []*NgingAccessLog {
	if a.objects == nil {
		return nil
	}
	return a.objects[:]
}

func (a *NgingAccessLog) XObjects() Slice_NgingAccessLog {
	return Slice_NgingAccessLog(a.Objects())
}

func (a *NgingAccessLog) NewObjects() factory.Ranger {
	return &Slice_NgingAccessLog{}
}

func (a *NgingAccessLog) InitObjects() *[]*NgingAccessLog {
	a.objects = []*NgingAccessLog{}
	return &a.objects
}

func (a *NgingAccessLog) NewParam() *factory.Param {
	return factory.NewParam(factory.DefaultFactory).SetIndex(a.base.ConnID()).SetTrans(a.base.Trans()).SetCollection(a.Name_()).SetModel(a)
}

func (a *NgingAccessLog) Short_() string {
	return "nging_access_log"
}

func (a *NgingAccessLog) Struct_() string {
	return "NgingAccessLog"
}

func (a *NgingAccessLog) Name_() string {
	if a.base.Namer() != nil {
		return WithPrefix(a.base.Namer()(a))
	}
	return WithPrefix(factory.TableNamerGet(a.Short_())(a))
}

func (a *NgingAccessLog) CPAFrom(source factory.Model) factory.Model {
	a.SetContext(source.Context())
	a.Use(source.Trans())
	a.SetNamer(source.Namer())
	return a
}

func (a *NgingAccessLog) Get(mw func(db.Result) db.Result, args ...interface{}) (err error) {
	base := a.base
	if !a.base.Eventable() {
		err = a.Param(mw, args...).SetRecv(a).One()
		a.base = base
		return
	}
	queryParam := a.Param(mw, args...).SetRecv(a)
	if err = DBI.FireReading(a, queryParam); err != nil {
		return
	}
	err = queryParam.One()
	a.base = base
	if err == nil {
		err = DBI.FireReaded(a, queryParam)
	}
	return
}

func (a *NgingAccessLog) List(recv interface{}, mw func(db.Result) db.Result, page, size int, args ...interface{}) (func() int64, error) {
	if recv == nil {
		recv = a.InitObjects()
	}
	if !a.base.Eventable() {
		return a.Param(mw, args...).SetPage(page).SetSize(size).SetRecv(recv).List()
	}
	queryParam := a.Param(mw, args...).SetPage(page).SetSize(size).SetRecv(recv)
	if err := DBI.FireReading(a, queryParam); err != nil {
		return nil, err
	}
	cnt, err := queryParam.List()
	if err == nil {
		switch v := recv.(type) {
		case *[]*NgingAccessLog:
			err = DBI.FireReaded(a, queryParam, Slice_NgingAccessLog(*v))
		case []*NgingAccessLog:
			err = DBI.FireReaded(a, queryParam, Slice_NgingAccessLog(v))
		case factory.Ranger:
			err = DBI.FireReaded(a, queryParam, v)
		}
	}
	return cnt, err
}

func (a *NgingAccessLog) GroupBy(keyField string, inputRows ...[]*NgingAccessLog) map[string][]*NgingAccessLog {
	var rows Slice_NgingAccessLog
	if len(inputRows) > 0 {
		rows = Slice_NgingAccessLog(inputRows[0])
	} else {
		rows = Slice_NgingAccessLog(a.Objects())
	}
	return rows.GroupBy(keyField)
}

func (a *NgingAccessLog) KeyBy(keyField string, inputRows ...[]*NgingAccessLog) map[string]*NgingAccessLog {
	var rows Slice_NgingAccessLog
	if len(inputRows) > 0 {
		rows = Slice_NgingAccessLog(inputRows[0])
	} else {
		rows = Slice_NgingAccessLog(a.Objects())
	}
	return rows.KeyBy(keyField)
}

func (a *NgingAccessLog) AsKV(keyField string, valueField string, inputRows ...[]*NgingAccessLog) param.Store {
	var rows Slice_NgingAccessLog
	if len(inputRows) > 0 {
		rows = Slice_NgingAccessLog(inputRows[0])
	} else {
		rows = Slice_NgingAccessLog(a.Objects())
	}
	return rows.AsKV(keyField, valueField)
}

func (a *NgingAccessLog) ListByOffset(recv interface{}, mw func(db.Result) db.Result, offset, size int, args ...interface{}) (func() int64, error) {
	if recv == nil {
		recv = a.InitObjects()
	}
	if !a.base.Eventable() {
		return a.Param(mw, args...).SetOffset(offset).SetSize(size).SetRecv(recv).List()
	}
	queryParam := a.Param(mw, args...).SetOffset(offset).SetSize(size).SetRecv(recv)
	if err := DBI.FireReading(a, queryParam); err != nil {
		return nil, err
	}
	cnt, err := queryParam.List()
	if err == nil {
		switch v := recv.(type) {
		case *[]*NgingAccessLog:
			err = DBI.FireReaded(a, queryParam, Slice_NgingAccessLog(*v))
		case []*NgingAccessLog:
			err = DBI.FireReaded(a, queryParam, Slice_NgingAccessLog(v))
		case factory.Ranger:
			err = DBI.FireReaded(a, queryParam, v)
		}
	}
	return cnt, err
}

func (a *NgingAccessLog) Insert() (pk interface{}, err error) {
	a.Created = uint(time.Now().Unix())
	a.Id = 0
	if len(a.TimeLocal) == 0 {
		a.TimeLocal = "1970-01-01 00:00:00"
	}
	if a.base.Eventable() {
		err = DBI.Fire("creating", a, nil)
		if err != nil {
			return
		}
	}
	pk, err = a.Param(nil).SetSend(a).Insert()
	if err == nil && pk != nil {
		if v, y := pk.(uint64); y {
			a.Id = v
		} else if v, y := pk.(int64); y {
			a.Id = uint64(v)
		}
	}
	if err == nil && a.base.Eventable() {
		err = DBI.Fire("created", a, nil)
	}
	return
}

func (a *NgingAccessLog) Update(mw func(db.Result) db.Result, args ...interface{}) (err error) {

	if len(a.TimeLocal) == 0 {
		a.TimeLocal = "1970-01-01 00:00:00"
	}
	if !a.base.Eventable() {
		return a.Param(mw, args...).SetSend(a).Update()
	}
	if err = DBI.Fire("updating", a, mw, args...); err != nil {
		return
	}
	if err = a.Param(mw, args...).SetSend(a).Update(); err != nil {
		return
	}
	return DBI.Fire("updated", a, mw, args...)
}

func (a *NgingAccessLog) Updatex(mw func(db.Result) db.Result, args ...interface{}) (affected int64, err error) {

	if len(a.TimeLocal) == 0 {
		a.TimeLocal = "1970-01-01 00:00:00"
	}
	if !a.base.Eventable() {
		return a.Param(mw, args...).SetSend(a).Updatex()
	}
	if err = DBI.Fire("updating", a, mw, args...); err != nil {
		return
	}
	if affected, err = a.Param(mw, args...).SetSend(a).Updatex(); err != nil {
		return
	}
	err = DBI.Fire("updated", a, mw, args...)
	return
}

func (a *NgingAccessLog) UpdateByFields(mw func(db.Result) db.Result, fields []string, args ...interface{}) (err error) {

	if len(a.TimeLocal) == 0 {
		a.TimeLocal = "1970-01-01 00:00:00"
	}
	if !a.base.Eventable() {
		return a.Param(mw, args...).UpdateByStruct(a, fields...)
	}
	editColumns := make([]string, len(fields))
	for index, field := range fields {
		editColumns[index] = com.SnakeCase(field)
	}
	if err = DBI.FireUpdate("updating", a, editColumns, mw, args...); err != nil {
		return
	}
	if err = a.Param(mw, args...).UpdateByStruct(a, fields...); err != nil {
		return
	}
	err = DBI.FireUpdate("updated", a, editColumns, mw, args...)
	return
}

func (a *NgingAccessLog) UpdatexByFields(mw func(db.Result) db.Result, fields []string, args ...interface{}) (affected int64, err error) {

	if len(a.TimeLocal) == 0 {
		a.TimeLocal = "1970-01-01 00:00:00"
	}
	if !a.base.Eventable() {
		return a.Param(mw, args...).UpdatexByStruct(a, fields...)
	}
	editColumns := make([]string, len(fields))
	for index, field := range fields {
		editColumns[index] = com.SnakeCase(field)
	}
	if err = DBI.FireUpdate("updating", a, editColumns, mw, args...); err != nil {
		return
	}
	if affected, err = a.Param(mw, args...).UpdatexByStruct(a, fields...); err != nil {
		return
	}
	err = DBI.FireUpdate("updated", a, editColumns, mw, args...)
	return
}

func (a *NgingAccessLog) UpdateField(mw func(db.Result) db.Result, field string, value interface{}, args ...interface{}) (err error) {
	return a.UpdateFields(mw, map[string]interface{}{
		field: value,
	}, args...)
}

func (a *NgingAccessLog) UpdateFields(mw func(db.Result) db.Result, kvset map[string]interface{}, args ...interface{}) (err error) {

	if val, ok := kvset["time_local"]; ok && val != nil {
		if v, ok := val.(string); ok && len(v) == 0 {
			kvset["time_local"] = "1970-01-01 00:00:00"
		}
	}
	if !a.base.Eventable() {
		return a.Param(mw, args...).SetSend(kvset).Update()
	}
	m := *a
	m.FromRow(kvset)
	var editColumns []string
	for column := range kvset {
		editColumns = append(editColumns, column)
	}
	if err = DBI.FireUpdate("updating", &m, editColumns, mw, args...); err != nil {
		return
	}
	if err = a.Param(mw, args...).SetSend(kvset).Update(); err != nil {
		return
	}
	return DBI.FireUpdate("updated", &m, editColumns, mw, args...)
}

func (a *NgingAccessLog) UpdateValues(mw func(db.Result) db.Result, keysValues *db.KeysValues, args ...interface{}) (err error) {
	if !a.base.Eventable() {
		return a.Param(mw, args...).SetSend(keysValues).Update()
	}
	m := *a
	m.FromRow(keysValues.Map())
	if err = DBI.FireUpdate("updating", &m, keysValues.Keys(), mw, args...); err != nil {
		return
	}
	if err = a.Param(mw, args...).SetSend(keysValues).Update(); err != nil {
		return
	}
	return DBI.FireUpdate("updated", &m, keysValues.Keys(), mw, args...)
}

func (a *NgingAccessLog) Upsert(mw func(db.Result) db.Result, args ...interface{}) (pk interface{}, err error) {
	pk, err = a.Param(mw, args...).SetSend(a).Upsert(func() error {
		if len(a.TimeLocal) == 0 {
			a.TimeLocal = "1970-01-01 00:00:00"
		}
		if !a.base.Eventable() {
			return nil
		}
		return DBI.Fire("updating", a, mw, args...)
	}, func() error {
		a.Created = uint(time.Now().Unix())
		a.Id = 0
		if len(a.TimeLocal) == 0 {
			a.TimeLocal = "1970-01-01 00:00:00"
		}
		if !a.base.Eventable() {
			return nil
		}
		return DBI.Fire("creating", a, nil)
	})
	if err == nil && pk != nil {
		if v, y := pk.(uint64); y {
			a.Id = v
		} else if v, y := pk.(int64); y {
			a.Id = uint64(v)
		}
	}
	if err == nil && a.base.Eventable() {
		if pk == nil {
			err = DBI.Fire("updated", a, mw, args...)
		} else {
			err = DBI.Fire("created", a, nil)
		}
	}
	return
}

func (a *NgingAccessLog) Delete(mw func(db.Result) db.Result, args ...interface{}) (err error) {

	if !a.base.Eventable() {
		return a.Param(mw, args...).Delete()
	}
	if err = DBI.Fire("deleting", a, mw, args...); err != nil {
		return
	}
	if err = a.Param(mw, args...).Delete(); err != nil {
		return
	}
	return DBI.Fire("deleted", a, mw, args...)
}

func (a *NgingAccessLog) Deletex(mw func(db.Result) db.Result, args ...interface{}) (affected int64, err error) {

	if !a.base.Eventable() {
		return a.Param(mw, args...).Deletex()
	}
	if err = DBI.Fire("deleting", a, mw, args...); err != nil {
		return
	}
	if affected, err = a.Param(mw, args...).Deletex(); err != nil {
		return
	}
	err = DBI.Fire("deleted", a, mw, args...)
	return
}

func (a *NgingAccessLog) Count(mw func(db.Result) db.Result, args ...interface{}) (int64, error) {
	return a.Param(mw, args...).Count()
}

func (a *NgingAccessLog) Exists(mw func(db.Result) db.Result, args ...interface{}) (bool, error) {
	return a.Param(mw, args...).Exists()
}

func (a *NgingAccessLog) Reset() *NgingAccessLog {
	a.Id = 0
	a.VhostId = 0
	a.RemoteAddr = ``
	a.XRealIp = ``
	a.XForwardFor = ``
	a.LocalAddr = ``
	a.Elapsed = 0.0
	a.Host = ``
	a.User = ``
	a.TimeLocal = ``
	a.Minute = ``
	a.Method = ``
	a.Uri = ``
	a.Version = ``
	a.StatusCode = 0
	a.BodyBytes = 0
	a.Referer = ``
	a.UserAgent = ``
	a.HitStatus = 0
	a.Scheme = ``
	a.BrowerName = ``
	a.BrowerType = ``
	a.Created = 0
	return a
}

func (a *NgingAccessLog) AsMap(onlyFields ...string) param.Store {
	r := param.Store{}
	if len(onlyFields) == 0 {
		r["Id"] = a.Id
		r["VhostId"] = a.VhostId
		r["RemoteAddr"] = a.RemoteAddr
		r["XRealIp"] = a.XRealIp
		r["XForwardFor"] = a.XForwardFor
		r["LocalAddr"] = a.LocalAddr
		r["Elapsed"] = a.Elapsed
		r["Host"] = a.Host
		r["User"] = a.User
		r["TimeLocal"] = a.TimeLocal
		r["Minute"] = a.Minute
		r["Method"] = a.Method
		r["Uri"] = a.Uri
		r["Version"] = a.Version
		r["StatusCode"] = a.StatusCode
		r["BodyBytes"] = a.BodyBytes
		r["Referer"] = a.Referer
		r["UserAgent"] = a.UserAgent
		r["HitStatus"] = a.HitStatus
		r["Scheme"] = a.Scheme
		r["BrowerName"] = a.BrowerName
		r["BrowerType"] = a.BrowerType
		r["Created"] = a.Created
		return r
	}
	for _, field := range onlyFields {
		switch field {
		case "Id":
			r["Id"] = a.Id
		case "VhostId":
			r["VhostId"] = a.VhostId
		case "RemoteAddr":
			r["RemoteAddr"] = a.RemoteAddr
		case "XRealIp":
			r["XRealIp"] = a.XRealIp
		case "XForwardFor":
			r["XForwardFor"] = a.XForwardFor
		case "LocalAddr":
			r["LocalAddr"] = a.LocalAddr
		case "Elapsed":
			r["Elapsed"] = a.Elapsed
		case "Host":
			r["Host"] = a.Host
		case "User":
			r["User"] = a.User
		case "TimeLocal":
			r["TimeLocal"] = a.TimeLocal
		case "Minute":
			r["Minute"] = a.Minute
		case "Method":
			r["Method"] = a.Method
		case "Uri":
			r["Uri"] = a.Uri
		case "Version":
			r["Version"] = a.Version
		case "StatusCode":
			r["StatusCode"] = a.StatusCode
		case "BodyBytes":
			r["BodyBytes"] = a.BodyBytes
		case "Referer":
			r["Referer"] = a.Referer
		case "UserAgent":
			r["UserAgent"] = a.UserAgent
		case "HitStatus":
			r["HitStatus"] = a.HitStatus
		case "Scheme":
			r["Scheme"] = a.Scheme
		case "BrowerName":
			r["BrowerName"] = a.BrowerName
		case "BrowerType":
			r["BrowerType"] = a.BrowerType
		case "Created":
			r["Created"] = a.Created
		}
	}
	return r
}

func (a *NgingAccessLog) FromRow(row map[string]interface{}) {
	for key, value := range row {
		switch key {
		case "id":
			a.Id = param.AsUint64(value)
		case "vhost_id":
			a.VhostId = param.AsUint(value)
		case "remote_addr":
			a.RemoteAddr = param.AsString(value)
		case "x_real_ip":
			a.XRealIp = param.AsString(value)
		case "x_forward_for":
			a.XForwardFor = param.AsString(value)
		case "local_addr":
			a.LocalAddr = param.AsString(value)
		case "elapsed":
			a.Elapsed = param.AsFloat64(value)
		case "host":
			a.Host = param.AsString(value)
		case "user":
			a.User = param.AsString(value)
		case "time_local":
			a.TimeLocal = param.AsString(value)
		case "minute":
			a.Minute = param.AsString(value)
		case "method":
			a.Method = param.AsString(value)
		case "uri":
			a.Uri = param.AsString(value)
		case "version":
			a.Version = param.AsString(value)
		case "status_code":
			a.StatusCode = param.AsUint(value)
		case "body_bytes":
			a.BodyBytes = param.AsUint64(value)
		case "referer":
			a.Referer = param.AsString(value)
		case "user_agent":
			a.UserAgent = param.AsString(value)
		case "hit_status":
			a.HitStatus = param.AsUint(value)
		case "scheme":
			a.Scheme = param.AsString(value)
		case "brower_name":
			a.BrowerName = param.AsString(value)
		case "brower_type":
			a.BrowerType = param.AsString(value)
		case "created":
			a.Created = param.AsUint(value)
		}
	}
}

func (a *NgingAccessLog) Set(key interface{}, value ...interface{}) {
	switch k := key.(type) {
	case map[string]interface{}:
		for kk, vv := range k {
			a.Set(kk, vv)
		}
	default:
		var (
			kk string
			vv interface{}
		)
		if k, y := key.(string); y {
			kk = k
		} else {
			kk = fmt.Sprint(key)
		}
		if len(value) > 0 {
			vv = value[0]
		}
		switch kk {
		case "Id":
			a.Id = param.AsUint64(vv)
		case "VhostId":
			a.VhostId = param.AsUint(vv)
		case "RemoteAddr":
			a.RemoteAddr = param.AsString(vv)
		case "XRealIp":
			a.XRealIp = param.AsString(vv)
		case "XForwardFor":
			a.XForwardFor = param.AsString(vv)
		case "LocalAddr":
			a.LocalAddr = param.AsString(vv)
		case "Elapsed":
			a.Elapsed = param.AsFloat64(vv)
		case "Host":
			a.Host = param.AsString(vv)
		case "User":
			a.User = param.AsString(vv)
		case "TimeLocal":
			a.TimeLocal = param.AsString(vv)
		case "Minute":
			a.Minute = param.AsString(vv)
		case "Method":
			a.Method = param.AsString(vv)
		case "Uri":
			a.Uri = param.AsString(vv)
		case "Version":
			a.Version = param.AsString(vv)
		case "StatusCode":
			a.StatusCode = param.AsUint(vv)
		case "BodyBytes":
			a.BodyBytes = param.AsUint64(vv)
		case "Referer":
			a.Referer = param.AsString(vv)
		case "UserAgent":
			a.UserAgent = param.AsString(vv)
		case "HitStatus":
			a.HitStatus = param.AsUint(vv)
		case "Scheme":
			a.Scheme = param.AsString(vv)
		case "BrowerName":
			a.BrowerName = param.AsString(vv)
		case "BrowerType":
			a.BrowerType = param.AsString(vv)
		case "Created":
			a.Created = param.AsUint(vv)
		}
	}
}

func (a *NgingAccessLog) AsRow(onlyFields ...string) param.Store {
	r := param.Store{}
	if len(onlyFields) == 0 {
		r["id"] = a.Id
		r["vhost_id"] = a.VhostId
		r["remote_addr"] = a.RemoteAddr
		r["x_real_ip"] = a.XRealIp
		r["x_forward_for"] = a.XForwardFor
		r["local_addr"] = a.LocalAddr
		r["elapsed"] = a.Elapsed
		r["host"] = a.Host
		r["user"] = a.User
		r["time_local"] = a.TimeLocal
		r["minute"] = a.Minute
		r["method"] = a.Method
		r["uri"] = a.Uri
		r["version"] = a.Version
		r["status_code"] = a.StatusCode
		r["body_bytes"] = a.BodyBytes
		r["referer"] = a.Referer
		r["user_agent"] = a.UserAgent
		r["hit_status"] = a.HitStatus
		r["scheme"] = a.Scheme
		r["brower_name"] = a.BrowerName
		r["brower_type"] = a.BrowerType
		r["created"] = a.Created
		return r
	}
	for _, field := range onlyFields {
		switch field {
		case "id":
			r["id"] = a.Id
		case "vhost_id":
			r["vhost_id"] = a.VhostId
		case "remote_addr":
			r["remote_addr"] = a.RemoteAddr
		case "x_real_ip":
			r["x_real_ip"] = a.XRealIp
		case "x_forward_for":
			r["x_forward_for"] = a.XForwardFor
		case "local_addr":
			r["local_addr"] = a.LocalAddr
		case "elapsed":
			r["elapsed"] = a.Elapsed
		case "host":
			r["host"] = a.Host
		case "user":
			r["user"] = a.User
		case "time_local":
			r["time_local"] = a.TimeLocal
		case "minute":
			r["minute"] = a.Minute
		case "method":
			r["method"] = a.Method
		case "uri":
			r["uri"] = a.Uri
		case "version":
			r["version"] = a.Version
		case "status_code":
			r["status_code"] = a.StatusCode
		case "body_bytes":
			r["body_bytes"] = a.BodyBytes
		case "referer":
			r["referer"] = a.Referer
		case "user_agent":
			r["user_agent"] = a.UserAgent
		case "hit_status":
			r["hit_status"] = a.HitStatus
		case "scheme":
			r["scheme"] = a.Scheme
		case "brower_name":
			r["brower_name"] = a.BrowerName
		case "brower_type":
			r["brower_type"] = a.BrowerType
		case "created":
			r["created"] = a.Created
		}
	}
	return r
}

func (a *NgingAccessLog) ListPage(cond *db.Compounds, sorts ...interface{}) error {
	_, err := pagination.NewLister(a, nil, func(r db.Result) db.Result {
		return r.OrderBy(sorts...)
	}, cond.And()).Paging(a.Context())
	return err
}

func (a *NgingAccessLog) ListPageAs(recv interface{}, cond *db.Compounds, sorts ...interface{}) error {
	_, err := pagination.NewLister(a, recv, func(r db.Result) db.Result {
		return r.OrderBy(sorts...)
	}, cond.And()).Paging(a.Context())
	return err
}

func (a *NgingAccessLog) BatchValidate(kvset map[string]interface{}) error {
	if kvset == nil {
		kvset = a.AsRow()
	}
	return DBI.Fields.BatchValidate(a.Short_(), kvset)
}

func (a *NgingAccessLog) Validate(field string, value interface{}) error {
	return DBI.Fields.Validate(a.Short_(), field, value)
}
